﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Charts;

namespace DragDropSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        bool isPressed;

        bool isDragging;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void chart_MouseDown(object sender, MouseButtonEventArgs e)
        {
            isPressed = true;
        }

        private void chart_MouseMove(object sender, MouseEventArgs e)
        {
            if (isPressed &&!isDragging)
            {
                //Added the data points when move the mouse on the chart area.
                Point currentPosition = new Point
                {
                    X = e.GetPosition(chart.AdorningCanvas).X - chart.SeriesClipRect.Left,

                    Y = e.GetPosition(chart.AdorningCanvas).Y - chart.SeriesClipRect.Top

                };
                Model model = new Model();

                model.XData =  (sender as CustomChart).PointToValue(chart.PrimaryAxis, currentPosition);

                model.YData = (sender as CustomChart).PointToValue(chart.SecondaryAxis, currentPosition);

                (fastSeries.ItemsSource as ObservableCollection<Model>).Add(model);
            }
        }

        private void chart_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            isPressed = false;
        }

        private void fastSeries_DragStart(object sender, ChartDragStartEventArgs e)
        {
            isDragging = true;
        }

        private void fastSeries_DragEnd(object sender, ChartDragEndEventArgs e)
        {
            isDragging = false;
        }
    }

    public class Model
    {
        public double? XData { get; set; }

        public double? YData { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            Datas = new ObservableCollection<Model>();
        }

        public ObservableCollection<Model> Datas { get; set; }
    }

    public class CustomChart : SfChart
    {
        public Canvas AdorningCanvas;
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            AdorningCanvas = GetTemplateChild("adorningCanvas") as Canvas;
        }
    }

}
